main:
  call InitSensors(0,0,0,0)
  Dim CntInfo[9,9]
  BMP="BMP"
  JPG="JPG"
  dx=800/9 // scrn resolution is 800x600
  dy=600/9
  // wait 3 seconds then take picture
  delay 3000
  call GetImage("Cam1 10",BMP)
  // display image
  FitBmp "Temp"
  // show grid for clarity
  for i=0 to 800 step dx 
    line i,0,i,600,1,LightBlue
  next
  for i=0 to 600 step dy
    line 0,i,800,i,1,LightBlue
  next
  xyString 230,550, "Touch the object to be found"
  repeat
    ReadMouse x,y,b
  until b
  // record objects color in col
  ReadPixel x,y,col
  // track object continuously 
  while true
    call GetImage("Cam1 10",BMP)
    // display image
    Found=-1
    FitBmp "Temp"
    BMPfindClr "Temp",col,Found,SecCnt,.2,.05,9,CntInfo
    if Found>-1
      // determine grid coordinates of found block
      x=Found#9
      y=Found/9
      // outline the block in red
      line x*dx,y*dy,(x+1)*dx,y*dy,4,red
      lineto (x+1)*dx,(y+1)*dy,4,red
      lineto x*dx,(y+1)*dy,4,red
      lineto x*dx,y*dy,4,red 
    endif
  wend
end

sub GetImage(Command,type)  
  FileDelete("Temp.jpg")
  // tell the Utility to take the picture
  SetCBtext(Command) 
  FileRename ("RBsTurn.txt","SensorsTurn.txt")  
  If type="BMP" then FileDelete("Temp.bmp")
  // wait for handshake
  while !FileExists("Temp.jpg")
  wend
  delay 100
  if type="BMP" then ToBmp "Temp.jpg"
return

sub InitSensors(a,b,c,d)
  // The Utility MUST reside in the same directory as
  // the application unless you set up paths 
  print "Initializing..."
  SetCBtext("stop") // stop utility if running
  filerename ("RBsTurn.txt","SensorsTurn.txt")
  delay 100
  Spawn ("RBsensorUtility.exe","",P_NOWAIT) 
  // provide time for Utility to spawn
  delay 1000 
  ClearScr   
  //  The above code can be eliminated if you always
  //  start the Utility manually. We have code in
  //  the utility that SHOULD prevent a second copy
  //  from running - but for some unknown reason it
  //  is not 100% reliable.  The above code seems to
  //  always work on our machine.
  dim Sensors[28] //max available from utility
  dim Offsets[4]                 
  for i=0 to 27
    Sensors[i]=""
  next
  // allow setting certain angles to zero
  Offsets[0]=a
  Offsets[1]=b
  Offsets[2]=c
  Offsets[3]=d 
  // note: new initialization will be added here for voice commands 
return  



